diff --git a/libpurple/protocols/gg/avatar.h b/libpurple/protocols/gg/avatar.h
--- a/libpurple/protocols/gg/avatar.h
+++ b/libpurple/protocols/gg/avatar.h
@@ -41,6 +41,6 @@
 void ggp_avatar_buddy_update(PurpleConnection *gc, uin_t uin, time_t timestamp);
 void ggp_avatar_buddy_remove(PurpleConnection *gc, uin_t uin);
 
-void ggp_avatar_own_set(PurpleConnection *gc, PurpleImage *img);
+void ggp_avatar_own_set(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleImage *img);
 
 #endif /* PURPLE_GG_AVATAR_H */
diff --git a/libpurple/protocols/gg/avatar.c b/libpurple/protocols/gg/avatar.c
--- a/libpurple/protocols/gg/avatar.c
+++ b/libpurple/protocols/gg/avatar.c
@@ -286,7 +286,8 @@
 }
 
 void
-ggp_avatar_own_set(PurpleConnection *gc, PurpleImage *img)
+ggp_avatar_own_set(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                   PurpleImage *img)
 {
 	ggp_avatar_session_data *avdata;
 
diff --git a/libpurple/protocols/gg/gg.c b/libpurple/protocols/gg/gg.c
--- a/libpurple/protocols/gg/gg.c
+++ b/libpurple/protocols/gg/gg.c
@@ -889,7 +889,9 @@
 	return 1; /* wait 1 second before another notification */
 }
 
-static void ggp_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group, const char *message)
+static void
+ggp_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+              PurpleBuddy *buddy, PurpleGroup *group, const gchar *message)
 {
 	PurpleAccount *account = purple_connection_get_account(gc);
 	GGPInfo *info = purple_connection_get_protocol_data(gc);
@@ -901,21 +903,22 @@
 	if (purple_strequal(purple_account_get_username(account), name))
 		ggp_status_fake_to_self(gc);
 
-	ggp_roster_add_buddy(gc, buddy, group, message);
+	ggp_roster_add_buddy(protocol_server, gc, buddy, group, message);
 	ggp_pubdir_request_buddy_alias(gc, buddy);
 }
 
-static void ggp_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-	PurpleGroup *group)
+static void
+ggp_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                 PurpleBuddy *buddy, PurpleGroup *group)
 {
 	GGPInfo *info = purple_connection_get_protocol_data(gc);
 
 	gg_remove_notify(info->session, ggp_str_to_uin(purple_buddy_get_name(buddy)));
-	ggp_roster_remove_buddy(gc, buddy, group);
+	ggp_roster_remove_buddy(protocol_server, gc, buddy, group);
 }
 
-static void ggp_keepalive(PurpleConnection *gc)
-{
+static void
+ggp_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *gc) {
 	GGPInfo *info = purple_connection_get_protocol_data(gc);
 
 	/* purple_debug_info("gg", "Keeping connection alive....\n"); */
diff --git a/libpurple/protocols/gg/pubdir-prpl.h b/libpurple/protocols/gg/pubdir-prpl.h
--- a/libpurple/protocols/gg/pubdir-prpl.h
+++ b/libpurple/protocols/gg/pubdir-prpl.h
@@ -62,7 +62,7 @@
 void ggp_pubdir_get_info(PurpleConnection *gc, uin_t uin,
 	ggp_pubdir_request_cb cb, void *user_data);
 
-void ggp_pubdir_get_info_protocol(PurpleConnection *gc, const char *name);
+void ggp_pubdir_get_info_protocol(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *name);
 void ggp_pubdir_request_buddy_alias(PurpleConnection *gc, PurpleBuddy *buddy);
 
 void ggp_pubdir_search(PurpleConnection *gc,
diff --git a/libpurple/protocols/gg/pubdir-prpl.c b/libpurple/protocols/gg/pubdir-prpl.c
--- a/libpurple/protocols/gg/pubdir-prpl.c
+++ b/libpurple/protocols/gg/pubdir-prpl.c
@@ -406,7 +406,8 @@
 }
 
 void
-ggp_pubdir_get_info_protocol(PurpleConnection *gc, const char *name)
+ggp_pubdir_get_info_protocol(PurpleProtocolServer *protocol_server,
+                             PurpleConnection *gc, const gchar *name)
 {
 	uin_t uin = ggp_str_to_uin(name);
 	uin_t *uin_p = g_new0(uin_t, 1);
@@ -606,7 +607,7 @@
 static void
 ggp_pubdir_search_results_info(PurpleConnection *gc, GList *row, gpointer _form)
 {
-	ggp_pubdir_get_info_protocol(gc, g_list_nth_data(row, 0));
+	ggp_pubdir_get_info_protocol(NULL, gc, g_list_nth_data(row, 0));
 }
 
 static void
diff --git a/libpurple/protocols/gg/roster.h b/libpurple/protocols/gg/roster.h
--- a/libpurple/protocols/gg/roster.h
+++ b/libpurple/protocols/gg/roster.h
@@ -59,15 +59,15 @@
 	struct gg_event_userlist100_version *version);
 
 /* libpurple callbacks */
-void ggp_roster_alias_buddy(PurpleConnection *gc, const char *who,
+void ggp_roster_alias_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *who,
 	const char *alias);
-void ggp_roster_group_buddy(PurpleConnection *gc, const char *who,
+void ggp_roster_group_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *who,
 	const char *old_group, const char *new_group);
-void ggp_roster_rename_group(PurpleConnection *, const char *old_name,
+void ggp_roster_rename_group(PurpleProtocolServer *protocol_server, PurpleConnection *, const char *old_name,
 	PurpleGroup *group, GList *moved_buddies);
-void ggp_roster_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
+void ggp_roster_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleBuddy *buddy,
 	PurpleGroup *group, const char *message);
-void ggp_roster_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
+void ggp_roster_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleBuddy *buddy,
 	PurpleGroup *group);
 
 #endif /* PURPLE_GG_ROSTER_H */
diff --git a/libpurple/protocols/gg/roster.c b/libpurple/protocols/gg/roster.c
--- a/libpurple/protocols/gg/roster.c
+++ b/libpurple/protocols/gg/roster.c
@@ -341,8 +341,10 @@
  * Libpurple callbacks.
  ******************************************************************************/
 
-void ggp_roster_alias_buddy(PurpleConnection *gc, const char *who,
-	const char *alias)
+void
+ggp_roster_alias_buddy(PurpleProtocolServer *protocol_server,
+                       PurpleConnection *gc, const gchar *who,
+                       const gchar *alias)
 {
 	PurpleBuddy *buddy;
 
@@ -360,8 +362,10 @@
 	ggp_roster_set_synchronized(gc, buddy, FALSE);
 }
 
-void ggp_roster_group_buddy(PurpleConnection *gc, const char *who,
-	const char *old_group, const char *new_group)
+void
+ggp_roster_group_buddy(PurpleProtocolServer *protocol_server,
+                       PurpleConnection *gc, const gchar *who,
+                       const gchar *old_group, const gchar *new_group)
 {
 	ggp_roster_session_data *rdata = ggp_roster_get_rdata(gc);
 	ggp_roster_change *change;
@@ -382,8 +386,10 @@
 	rdata->pending_updates = g_list_append(rdata->pending_updates, change);
 }
 
-void ggp_roster_rename_group(PurpleConnection *gc, const char *old_name,
-	PurpleGroup *group, GList *moved_buddies)
+void
+ggp_roster_rename_group(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc, const gchar *old_name,
+                        PurpleGroup *group, GList *moved_buddies)
 {
 	ggp_roster_session_data *rdata = ggp_roster_get_rdata(gc);
 	ggp_roster_change *change;
@@ -399,8 +405,10 @@
 	rdata->pending_updates = g_list_append(rdata->pending_updates, change);
 }
 
-void ggp_roster_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-	PurpleGroup *group, const char *message)
+void
+ggp_roster_add_buddy(PurpleProtocolServer *protocol_server,
+                     PurpleConnection *gc, PurpleBuddy *buddy,
+                     PurpleGroup *group, const gchar *message)
 {
 	g_return_if_fail(gc != NULL);
 	g_return_if_fail(buddy != NULL);
@@ -411,8 +419,10 @@
 	ggp_roster_set_synchronized(gc, buddy, FALSE);
 }
 
-void ggp_roster_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-	PurpleGroup *group)
+void
+ggp_roster_remove_buddy(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc, PurpleBuddy *buddy,
+                        PurpleGroup *group)
 {
 	ggp_roster_session_data *rdata = ggp_roster_get_rdata(gc);
 	ggp_roster_change *change;
diff --git a/libpurple/protocols/gg/status.h b/libpurple/protocols/gg/status.h
--- a/libpurple/protocols/gg/status.h
+++ b/libpurple/protocols/gg/status.h
@@ -48,7 +48,7 @@
 void ggp_status_set_initial(PurpleConnection *gc, struct gg_login_params *glp);
 
 gboolean ggp_status_set(PurpleAccount *account, int status, const gchar* msg);
-void ggp_status_set_purplestatus(PurpleAccount *account, PurpleStatus *status);
+void ggp_status_set_purplestatus(PurpleProtocolServer *protocol_server, PurpleAccount *account, PurpleStatus *status);
 void ggp_status_set_disconnected(PurpleAccount *account);
 void ggp_status_fake_to_self(PurpleConnection *gc);
 
diff --git a/libpurple/protocols/gg/status.c b/libpurple/protocols/gg/status.c
--- a/libpurple/protocols/gg/status.c
+++ b/libpurple/protocols/gg/status.c
@@ -249,7 +249,9 @@
 	return TRUE;
 }
 
-void ggp_status_set_purplestatus(PurpleAccount *account, PurpleStatus *status)
+void
+ggp_status_set_purplestatus(PurpleProtocolServer *protocol_server,
+                            PurpleAccount *account, PurpleStatus *status)
 {
 	int status_gg;
 	gchar *msg = NULL;
@@ -330,7 +332,7 @@
 
 	ggp_status_get_ssdata(gc)->status_broadcasting = broadcasting;
 	purple_account_set_bool(account, "status_broadcasting", broadcasting);
-	ggp_status_set_purplestatus(account,
+	ggp_status_set_purplestatus(NULL, account,
 		purple_account_get_active_status(account));
 }
 
diff --git a/libpurple/protocols/irc/irc.c b/libpurple/protocols/irc/irc.c
--- a/libpurple/protocols/irc/irc.c
+++ b/libpurple/protocols/irc/irc.c
@@ -221,7 +221,9 @@
 	g_free(body);
 }
 
-static int irc_send_raw(PurpleConnection *gc, const char *buf, int len)
+static int
+irc_send_raw(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+             const gchar *buf, gint len)
 {
 	struct irc_conn *irc = purple_connection_get_protocol_data(gc);
 	if (len == -1) {
@@ -644,7 +646,9 @@
 	return 1;
 }
 
-static void irc_get_info(PurpleConnection *gc, const char *who)
+static void
+irc_get_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+             const gchar *who)
 {
 	struct irc_conn *irc = purple_connection_get_protocol_data(gc);
 	const char *args[2];
@@ -653,7 +657,9 @@
 	irc_cmd_whois(irc, "whois", NULL, args);
 }
 
-static void irc_set_status(PurpleAccount *account, PurpleStatus *status)
+static void
+irc_set_status(PurpleProtocolServer *protocol_server, PurpleAccount *account,
+               PurpleStatus *status)
 {
 	PurpleConnection *gc = purple_account_get_connection(account);
 	struct irc_conn *irc;
@@ -678,7 +684,9 @@
 	}
 }
 
-static void irc_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group, const char *message)
+static void
+irc_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+              PurpleBuddy *buddy, PurpleGroup *group, const gchar *message)
 {
 	struct irc_conn *irc = purple_connection_get_protocol_data(gc);
 	struct irc_buddy *ib;
@@ -703,7 +711,9 @@
 		irc_ison_one(irc, ib);
 }
 
-static void irc_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group)
+static void
+irc_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                 PurpleBuddy *buddy, PurpleGroup *group)
 {
 	struct irc_conn *irc = purple_connection_get_protocol_data(gc);
 	struct irc_buddy *ib;
@@ -936,8 +946,8 @@
 	}
 }
 
-static void irc_keepalive(PurpleConnection *gc)
-{
+static void
+irc_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *gc) {
 	struct irc_conn *irc = purple_connection_get_protocol_data(gc);
 	if ((time(NULL) - irc->recv_time) > PING_TIMEOUT)
 		irc_cmd_ping(irc, NULL, NULL, NULL);
diff --git a/libpurple/protocols/irc/msgs.c b/libpurple/protocols/irc/msgs.c
--- a/libpurple/protocols/irc/msgs.c
+++ b/libpurple/protocols/irc/msgs.c
@@ -104,7 +104,7 @@
 	status = purple_account_get_active_status(irc->account);
 	if (purple_status_type_get_primitive(purple_status_get_status_type(status)) != PURPLE_STATUS_AVAILABLE) {
 		PurpleProtocol *protocol = purple_connection_get_protocol(gc);
-		purple_protocol_server_iface_set_status(protocol, irc->account, status);
+		purple_protocol_server_set_status(PURPLE_PROTOCOL_SERVER(protocol), irc->account, status);
 	}
 
 	/* this used to be in the core, but it's not now */
diff --git a/libpurple/protocols/jabber/buddy.h b/libpurple/protocols/jabber/buddy.h
--- a/libpurple/protocols/jabber/buddy.h
+++ b/libpurple/protocols/jabber/buddy.h
@@ -103,13 +103,13 @@
 JabberBuddyResource *jabber_buddy_track_resource(JabberBuddy *jb, const char *resource,
 		int priority, JabberBuddyState state, const char *status);
 void jabber_buddy_remove_resource(JabberBuddy *jb, const char *resource);
-void jabber_buddy_get_info(PurpleConnection *gc, const char *who);
+void jabber_buddy_get_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *who);
 
 GList *jabber_blist_node_menu(PurpleProtocolClient *client, PurpleBlistNode *node);
 
-void jabber_set_info(PurpleConnection *gc, const char *info);
+void jabber_set_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *info);
 void jabber_setup_set_info(PurpleProtocolAction *action);
-void jabber_set_buddy_icon(PurpleConnection *gc, PurpleImage *img);
+void jabber_set_buddy_icon(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleImage *img);
 
 void jabber_user_search(JabberStream *js, const char *directory);
 void jabber_user_search_begin(PurpleProtocolAction *);
diff --git a/libpurple/protocols/jabber/buddy.c b/libpurple/protocols/jabber/buddy.c
--- a/libpurple/protocols/jabber/buddy.c
+++ b/libpurple/protocols/jabber/buddy.c
@@ -449,7 +449,9 @@
 /*
  * Send vCard info to Jabber server
  */
-void jabber_set_info(PurpleConnection *gc, const char *info)
+void
+jabber_set_info(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                const gchar *info)
 {
 	PurpleImage *img;
 	JabberIq *iq;
@@ -546,14 +548,16 @@
 	}
 }
 
-void jabber_set_buddy_icon(PurpleConnection *gc, PurpleImage *img)
+void
+jabber_set_buddy_icon(PurpleProtocolServer *protocol_server,
+                      PurpleConnection *gc, PurpleImage *img)
 {
 	PurpleAccount *account = purple_connection_get_account(gc);
 
 	/* Publish the avatar as specified in XEP-0084 */
 	jabber_avatar_set(purple_connection_get_protocol_data(gc), img);
 	/* Set the image in our vCard */
-	jabber_set_info(gc, purple_account_get_user_info(account));
+	jabber_set_info(NULL, gc, purple_account_get_user_info(account));
 
 	/* TODO: Fake image to ourselves, since a number of servers do not echo
 	 * back our presence to us. To do this without uselessly copying the data
@@ -902,7 +906,7 @@
 
 	js->vcard_timer = 0;
 
-	jabber_set_info(js->gc, purple_account_get_user_info(account));
+	jabber_set_info(NULL, js->gc, purple_account_get_user_info(account));
 
 	return FALSE;
 }
@@ -962,11 +966,12 @@
 		 * it returns an error (namespaces trimmed):
 		 * <error code="500" type="wait"><internal-server-error/></error>.
 		 */
-		if (js->googletalk)
+		if (js->googletalk) {
 			js->vcard_timer = g_timeout_add_seconds(10, set_own_vcard_cb,
 			                                             js);
-		else
-			jabber_set_info(js->gc, purple_account_get_user_info(account));
+		} else {
+			jabber_set_info(NULL, js->gc, purple_account_get_user_info(account));
+		}
 	} else if (vcard_hash) {
 		/* A photo is in the vCard. Advertise its hash */
 		js->avatar_hash = vcard_hash;
@@ -1619,7 +1624,9 @@
 	jbi->timeout_handle = g_timeout_add_seconds(30, jabber_buddy_get_info_timeout, jbi);
 }
 
-void jabber_buddy_get_info(PurpleConnection *gc, const char *who)
+void
+jabber_buddy_get_info(PurpleProtocolServer *protocol_server,
+                      PurpleConnection *gc, const char *who)
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 	JabberID *jid = jabber_id_new(who);
diff --git a/libpurple/protocols/jabber/jabber.h b/libpurple/protocols/jabber/jabber.h
--- a/libpurple/protocols/jabber/jabber.h
+++ b/libpurple/protocols/jabber/jabber.h
@@ -325,7 +325,7 @@
 void jabber_stream_features_parse(JabberStream *js, PurpleXmlNode *packet);
 void jabber_process_packet(JabberStream *js, PurpleXmlNode **packet);
 void jabber_send(JabberStream *js, PurpleXmlNode *data);
-void jabber_send_raw(JabberStream *js, const char *data, int len);
+void jabber_send_raw(PurpleProtocolServer *protocol_server, JabberStream *js, const char *data, int len);
 void jabber_send_signal_cb(PurpleConnection *pc, PurpleXmlNode **packet,
                            gpointer unused);
 
@@ -404,23 +404,23 @@
 GList *jabber_status_types(PurpleAccount *account);
 void jabber_login(PurpleAccount *account);
 void jabber_close(PurpleConnection *gc);
-void jabber_idle_set(PurpleConnection *gc, int idle);
+void jabber_idle_set(PurpleProtocolServer *protocol_server, PurpleConnection *gc, int idle);
 void jabber_blocklist_parse_push(JabberStream *js, const char *from,
                                  JabberIqType type, const char *id,
                                  PurpleXmlNode *child);
 void jabber_request_block_list(JabberStream *js);
 void jabber_add_deny(PurpleProtocolPrivacy *privacy, PurpleConnection *gc, const char *who);
 void jabber_remove_deny(PurpleProtocolPrivacy *privacy, PurpleConnection *gc, const char *who);
-void jabber_keepalive(PurpleConnection *gc);
+void jabber_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *gc);
 void jabber_register_gateway(JabberStream *js, const char *gateway);
-void jabber_register_account(PurpleAccount *account);
-void jabber_unregister_account(PurpleAccount *account, PurpleAccountUnregistrationCb cb, void *user_data);
+void jabber_register_account(PurpleProtocolServer *protocol_server, PurpleAccount *account);
+void jabber_unregister_account(PurpleProtocolServer *protocol_server, PurpleAccount *account, PurpleAccountUnregistrationCb cb, void *user_data);
 gboolean jabber_send_attention(PurpleProtocolAttention *attn, PurpleConnection *gc, const char *username, guint code);
 GList *jabber_attention_types(PurpleProtocolAttention *attn, PurpleAccount *account);
 void jabber_convo_closed(PurpleProtocolClient *client, PurpleConnection *gc, const char *who);
 PurpleChat *jabber_find_blist_chat(PurpleProtocolClient *client, PurpleAccount *account, const char *name);
 gboolean jabber_offline_message(PurpleProtocolClient *client, PurpleBuddy *buddy);
-int jabber_protocol_send_raw(PurpleConnection *gc, const char *buf, int len);
+int jabber_protocol_send_raw(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const char *buf, int len);
 GList *jabber_get_actions(PurpleProtocolClient *client, PurpleConnection *gc);
 
 gboolean jabber_audio_enabled(JabberStream *js, const char *unused);
diff --git a/libpurple/protocols/jabber/jabber.c b/libpurple/protocols/jabber/jabber.c
--- a/libpurple/protocols/jabber/jabber.c
+++ b/libpurple/protocols/jabber/jabber.c
@@ -95,7 +95,7 @@
 						  js->user->domain);
 	/* setup the parser fresh for each stream */
 	jabber_parser_setup(js);
-	jabber_send_raw(js, open_stream, -1);
+	jabber_send_raw(NULL, js, open_stream, -1);
 	js->reinit = FALSE;
 	g_free(open_stream);
 }
@@ -225,7 +225,7 @@
 	 * We request STARTTLS for standard XMPP connections, but we do nothing for insecure
 	 * BOSH connections, per XEP-0206. */
 	if(!js->bosh) {
-		jabber_send_raw(js,
+		jabber_send_raw(NULL, js,
 				"<starttls xmlns='urn:ietf:params:xml:ns:xmpp-tls'/>", -1);
 		return TRUE;
 	}
@@ -408,7 +408,9 @@
 	return success;
 }
 
-void jabber_send_raw(JabberStream *js, const char *data, int len)
+void
+jabber_send_raw(PurpleProtocolServer *protocol_server, JabberStream *js,
+                const gchar *data, gint len)
 {
 	PurpleConnection *gc;
 	PurpleAccount *account;
@@ -514,7 +516,9 @@
 		do_jabber_send_raw(js, data, len);
 }
 
-int jabber_protocol_send_raw(PurpleConnection *gc, const char *buf, int len)
+gint
+jabber_protocol_send_raw(PurpleProtocolServer *protocol_server,
+                         PurpleConnection *gc, const gchar *buf, gint len)
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 
@@ -524,7 +528,7 @@
 	 * to do things during the connection process.
 	 */
 
-	jabber_send_raw(js, buf, len);
+	jabber_send_raw(NULL, js, buf, len);
 	return (len < 0 ? (int)strlen(buf) : len);
 }
 
@@ -551,7 +555,7 @@
 				purple_strequal((*packet)->name, "presence"))
 			purple_xmlnode_set_namespace(*packet, NS_XMPP_CLIENT);
 	txt = purple_xmlnode_to_str(*packet, &len);
-	jabber_send_raw(js, txt, len);
+	jabber_send_raw(NULL, js, txt, len);
 	g_free(txt);
 }
 
@@ -569,8 +573,8 @@
 	return FALSE;
 }
 
-void jabber_keepalive(PurpleConnection *gc)
-{
+void
+jabber_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *gc) {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 
 	if (js->keepalive_timeout == 0) {
@@ -580,8 +584,8 @@
 	}
 }
 
-static int jabber_get_keepalive_interval(void)
-{
+static int
+jabber_get_keepalive_interval(PurpleProtocolServer *protocol_server) {
 	return PING_TIMEOUT;
 }
 
@@ -731,7 +735,7 @@
 	        g_io_stream_get_output_stream(js->stream));
 
 	if (js->state == JABBER_STREAM_CONNECTING) {
-		jabber_send_raw(js, "<?xml version='1.0' ?>", -1);
+		jabber_send_raw(NULL, js, "<?xml version='1.0' ?>", -1);
 	}
 
 	jabber_stream_set_state(js, JABBER_STREAM_INITIALIZING);
@@ -1512,7 +1516,9 @@
 	jabber_iq_send(iq);
 }
 
-void jabber_register_account(PurpleAccount *account)
+void
+jabber_register_account(PurpleProtocolServer *protocol_server,
+                        PurpleAccount *account)
 {
 	JabberStream *js;
 
@@ -1566,7 +1572,11 @@
 	jabber_iq_send(iq);
 }
 
-void jabber_unregister_account(PurpleAccount *account, PurpleAccountUnregistrationCb cb, void *user_data) {
+void
+jabber_unregister_account(PurpleProtocolServer *protocol_server,
+                          PurpleAccount *account,
+                          PurpleAccountUnregistrationCb cb, gpointer user_data)
+{
 	PurpleConnection *gc = purple_account_get_connection(account);
 	JabberStream *js;
 
@@ -1771,7 +1781,9 @@
 }
 
 
-void jabber_idle_set(PurpleConnection *gc, int idle)
+void
+jabber_idle_set(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                gint idle)
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 
@@ -2098,10 +2110,11 @@
 	 */
 	js->inactivity_timer = 0;
 
-	if (js->bosh)
+	if (js->bosh) {
 		jabber_bosh_connection_send_keepalive(js->bosh);
-	else
-		jabber_send_raw(js, "\t", 1);
+	} else {
+		jabber_send_raw(NULL, js, "\t", 1);
+	}
 
 	return FALSE;
 }
diff --git a/libpurple/protocols/jabber/presence.h b/libpurple/protocols/jabber/presence.h
--- a/libpurple/protocols/jabber/presence.h
+++ b/libpurple/protocols/jabber/presence.h
@@ -84,7 +84,7 @@
 void jabber_presence_init(void);
 void jabber_presence_uninit(void);
 
-void jabber_set_status(PurpleAccount *account, PurpleStatus *status);
+void jabber_set_status(PurpleProtocolServer *protocol_server, PurpleAccount *account, PurpleStatus *status);
 
 /**
  *	Send a full presence stanza.
diff --git a/libpurple/protocols/jabber/presence.c b/libpurple/protocols/jabber/presence.c
--- a/libpurple/protocols/jabber/presence.c
+++ b/libpurple/protocols/jabber/presence.c
@@ -140,7 +140,9 @@
 	g_free(msg);
 }
 
-void jabber_set_status(PurpleAccount *account, PurpleStatus *status)
+void
+jabber_set_status(PurpleProtocolServer *protocol_server,
+                  PurpleAccount *account, PurpleStatus *status)
 {
 	PurpleConnection *gc;
 	JabberStream *js;
diff --git a/libpurple/protocols/jabber/roster.h b/libpurple/protocols/jabber/roster.h
--- a/libpurple/protocols/jabber/roster.h
+++ b/libpurple/protocols/jabber/roster.h
@@ -35,15 +35,15 @@
 void jabber_roster_parse(JabberStream *js, const char *from,
                          JabberIqType type, const char *id, PurpleXmlNode *query);
 
-void jabber_roster_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-		PurpleGroup *group, const char *message);
-void jabber_roster_alias_change(PurpleConnection *gc, const char *name,
-		const char *alias);
-void jabber_roster_group_change(PurpleConnection *gc, const char *name,
-		const char *old_group, const char *new_group);
-void jabber_roster_group_rename(PurpleConnection *gc, const char *old_name,
+void jabber_roster_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleBuddy *buddy,
+		PurpleGroup *group, const gchar *message);
+void jabber_roster_alias_change(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const gchar *name,
+		const gchar *alias);
+void jabber_roster_group_change(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const gchar *name,
+		const gchar *old_group, const gchar *new_group);
+void jabber_roster_group_rename(PurpleProtocolServer *protocol_server, PurpleConnection *gc, const gchar *old_name,
 		PurpleGroup *group, GList *moved_buddies);
-void jabber_roster_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
+void jabber_roster_remove_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc, PurpleBuddy *buddy,
 		PurpleGroup *group);
 
 const gchar *
diff --git a/libpurple/protocols/jabber/roster.c b/libpurple/protocols/jabber/roster.c
--- a/libpurple/protocols/jabber/roster.c
+++ b/libpurple/protocols/jabber/roster.c
@@ -351,8 +351,10 @@
 	jabber_iq_send(iq);
 }
 
-void jabber_roster_add_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-		PurpleGroup *group, const char *message)
+void
+jabber_roster_add_buddy(PurpleProtocolServer *protocol_server,
+                        PurpleConnection *gc, PurpleBuddy *buddy,
+                        PurpleGroup *group, const gchar *message)
 {
 	JabberStream *js = purple_connection_get_protocol_data(gc);
 	char *who;
@@ -415,7 +417,10 @@
 	g_free(who);
 }
 
-void jabber_roster_alias_change(PurpleConnection *gc, const char *name, const char *alias)
+void
+jabber_roster_alias_change(PurpleProtocolServer *protocol_server,
+                           PurpleConnection *gc, const gchar *name,
+                           const gchar *alias)
 {
 	PurpleBuddy *b = purple_blist_find_buddy(purple_connection_get_account(gc), name);
 
@@ -429,8 +434,10 @@
 	}
 }
 
-void jabber_roster_group_change(PurpleConnection *gc, const char *name,
-		const char *old_group, const char *new_group)
+void
+jabber_roster_group_change(PurpleProtocolServer *protocol_server,
+                           PurpleConnection *gc, const gchar *name,
+                           const gchar *old_group, const gchar *new_group)
 {
 	GSList *buddies, *groups = NULL;
 
@@ -449,19 +456,28 @@
 	jabber_roster_update(purple_connection_get_protocol_data(gc), name, groups);
 }
 
-void jabber_roster_group_rename(PurpleConnection *gc, const char *old_name,
-		PurpleGroup *group, GList *moved_buddies)
+void
+jabber_roster_group_rename(PurpleProtocolServer *protocol_server,
+                           PurpleConnection *gc, const gchar *old_name,
+                           PurpleGroup *group, GList *moved_buddies)
 {
 	GList *l;
 	const char *gname = jabber_roster_group_get_global_name(group);
+
 	for(l = moved_buddies; l; l = l->next) {
 		PurpleBuddy *buddy = l->data;
-		jabber_roster_group_change(gc, purple_buddy_get_name(buddy), old_name, gname);
+
+		jabber_roster_group_change(protocol_server, gc,
+		                           purple_buddy_get_name(buddy), old_name,
+		                           gname);
 	}
 }
 
-void jabber_roster_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy,
-		PurpleGroup *group) {
+void
+jabber_roster_remove_buddy(PurpleProtocolServer *protocol_server,
+                           PurpleConnection *gc, PurpleBuddy *buddy,
+                           PurpleGroup *group)
+{
 	const char *name = purple_buddy_get_name(buddy);
 	GSList *buddies = purple_blist_find_buddies(purple_connection_get_account(gc), name);
 
diff --git a/libpurple/protocols/novell/novell.c b/libpurple/protocols/novell/novell.c
--- a/libpurple/protocols/novell/novell.c
+++ b/libpurple/protocols/novell/novell.c
@@ -2557,7 +2557,8 @@
 }
 
 static void
-novell_add_buddy(PurpleConnection * gc, PurpleBuddy *buddy, PurpleGroup * group, const char *message)
+novell_add_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                 PurpleBuddy *buddy, PurpleGroup * group, const gchar *message)
 {
 	NMFolder *folder = NULL;
 	NMContact *contact;
@@ -2620,7 +2621,9 @@
 }
 
 static void
-novell_remove_buddy(PurpleConnection *gc, PurpleBuddy *buddy, PurpleGroup *group)
+novell_remove_buddy(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *gc, PurpleBuddy *buddy,
+                    PurpleGroup *group)
 {
 	NMContact *contact;
 	NMFolder *folder;
@@ -2655,7 +2658,8 @@
 }
 
 static void
-novell_remove_group(PurpleConnection * gc, PurpleGroup *group)
+novell_remove_group(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *gc, PurpleGroup *group)
 {
 	NMUser *user;
 	NMERR_T rc = NM_OK;
@@ -2676,7 +2680,8 @@
 }
 
 static void
-novell_alias_buddy(PurpleConnection * gc, const char *name, const char *alias)
+novell_alias_buddy(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                   const gchar *name, const gchar *alias)
 {
 	NMContact *contact;
 	NMUser *user;
@@ -2732,9 +2737,9 @@
 }
 
 static void
-novell_group_buddy(PurpleConnection * gc,
-				   const char *name, const char *old_group_name,
-				   const char *new_group_name)
+novell_group_buddy(PurpleProtocolServer *protocol_server,
+                   PurpleConnection *gc, const gchar *name,
+                   const gchar *old_group_name, const gchar *new_group_name)
 {
 	NMFolder *old_folder;
 	NMFolder *new_folder;
@@ -2794,7 +2799,8 @@
 }
 
 static void
-novell_rename_group(PurpleConnection * gc, const char *old_name,
+novell_rename_group(PurpleProtocolServer *protocol_server,
+                    PurpleConnection *gc, const gchar *old_name,
 					PurpleGroup *group, GList *moved_buddies)
 {
 	NMERR_T rc = NM_OK;
@@ -2894,7 +2900,8 @@
 }
 
 static void
-novell_set_idle(PurpleConnection * gc, int time)
+novell_set_idle(PurpleProtocolServer *protocol_server, PurpleConnection *gc,
+                gint time)
 {
 	NMUser *user;
 	NMERR_T rc = NM_OK;
@@ -2924,7 +2931,8 @@
 }
 
 static void
-novell_get_info(PurpleConnection * gc, const char *name)
+novell_get_info(PurpleProtocolServer *protocol_server, PurpleConnection * gc,
+                const gchar *name)
 {
 	NMUserRecord *user_record;
 	NMUser *user;
@@ -3020,7 +3028,8 @@
 }
 
 static void
-novell_set_status(PurpleAccount *account, PurpleStatus *status)
+novell_set_status(PurpleProtocolServer *protocol_server,
+                  PurpleAccount *account, PurpleStatus *status)
 {
 	PurpleConnection *gc;
 	gboolean connected;
@@ -3477,8 +3486,7 @@
 }
 
 static void
-novell_keepalive(PurpleConnection *gc)
-{
+novell_keepalive(PurpleProtocolServer *protocol_server, PurpleConnection *gc) {
 	NMUser *user;
 	NMERR_T rc = NM_OK;
 
